%公众号：工程师看海
%自相关函数
clc
close all
clear all

fsig = 1/(2*pi);    %信号频率
fsam =  10*fsig;    %采样频率
n = 3;              %采集n个周期

t = 0:1/(fsam):(n/fsig-1/(fsam/fsig));
noise = 5*rand(1,length(t));
X = sin(t);
Y = X + noise;
[a,b]=xcorr(X,'unbiased');
subplot(3,1,1);
plot(t,Y);
xlabel('Y=sin(t)+noise');
axis([0 t(length(t)) -inf inf]);

subplot(3,1,2);
plot(1/(fsam)*b,a);
xlabel('自相关函数');
axis([0 t(length(t)) -inf inf]);
subplot(3,1,3);

plot(t,X);
xlabel('sin(t)');
axis([0 t(length(t)) -inf inf]);

a
