%公众号：工程师看海
%相关系数
clc
close all
clear all
fsig = 1/(2*pi);    %信号频率
fsam =  10*fsig;    %采样频率

t = 0:1/(fsam):(1/fsig-1/(fsam/fsig));
X = sin(t);
Y = 0.5 + 0.5*sin(t);
X_Y = X.*Y;

E_X = sum(X)/length(X);
E_Y = sum(Y)/length(Y);
E_X_Y = sum(X_Y)/length(X_Y);

Cov_me = E_X_Y - E_X*E_Y; %协方差

DX = sum((X-E_X).*(X-E_X))/length(X);
DY = sum((Y-E_Y).*(Y-E_Y))/length(Y);

co = Cov_me/(sqrt(DX)*sqrt(DY)) %相关系数

corrcoef(X,Y) %相关系数
